chiark / gitweb /
Merge branch 'master' of git.distorted.org.uk:~mdw/publish/public-git/profile
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
82c688c7 13: ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
188ebb31
MW
107 ../configure \
108 --prefix=$HOME$sub \
109 PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110 >>buildlog 2>&1
f617db13
MW
111 $echon " building$echoc"
112 make >>buildlog 2>&1
113 $echon " installing$echoc"
114 make install >>buildlog 2>&1
115 echo " done."
116 )
117 fi
118done
852cd5fb 119echo " all done."
f617db13 120
ce178f96
MW
121###--------------------------------------------------------------------------
122### Install global configuration.
123
f141fe0f
MW
124echo -n "Installing dotfile configuration:"
125if [ -f $HOME$sub/.mdw.conf ]; then
126 echo " already installed."
127else
128 cp mdw.conf $HOME$sub/.mdw.conf
129 echo " done."
130fi
131
ce178f96 132## Symlink the various dotfiles into place
852cd5fb 133dotfiles="
be7dba95 134 bash_profile bash_logout bashrc inputrc bash_completion
54896c4f 135 emacs emacs-calc vm gnus.el ercrc.el
4fc3203b 136 vimrc mg zile lesskey
30169591 137 ditz-config
ce39049e 138 mailrc signature muttrc
ce178f96 139 cgrc tigrc
e7d23024 140 gdbinit
8a7e906d 141 guile
1d89ce86 142 rcrc
5d25e440 143 toprc
a6a6806a 144 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
cbffcf2b 145 aspell.conf
78719982 146 tclshrc:.tclshrc tclshrc:.wishrc
ccaac00b
MW
147 lisp-init.lisp:.cmucl-init.lisp
148 lisp-init.lisp:.sbclrc
149 lisp-init.lisp:.clisprc.lisp
f6335a0c 150 lisp-init.lisp:.eclrc
b5bf3445 151 swank.lisp
3ec64a11 152 w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
2425eca9 153 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 154[ "$xstuff" ] && dotfiles="$dotfiles
cd38b61d 155 xinitrc xsession xmodmap Xdefaults vncrc vncsession
5e23020b 156 fonts.conf
e517857c 157 stalonetrayrc
1c6b19d4 158 putty-defaults:.putty/sessions/Default%20Settings
2e60c7f3 159 mdw.session:.config/gnome-session/sessions/mdw.session
7cfa1f1a 160 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 161 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 162 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
f4e43257 163 e16-bindings:.e16/bindings.cfg"
f617db13
MW
164echo "Installing dotfiles..."
165for d in $dotfiles; do
739bccbf
MW
166 target=.$d
167 case $d in
168 *:*) target=${d#*:} d=${d%%:*};;
169 esac
170 ft=$HOME$sub/$target
171 dir=${ft%/*}
172 mkdir -p $dir
99063107 173 ln -s $here/dot/$d $ft.new
739bccbf
MW
174 mv $ft.new $ft
175 echo " $target"
f617db13 176done
852cd5fb 177echo " all done."
f617db13 178
403dc178
MW
179## Substitute things which need substituting.
180dotfilessubst="
181 gitconfig
8508a859 182 mykermrc
403dc178
MW
183 pulse-default.pa.in:.pulse/default.pa"
184echo "Installing dotfiles with substitutions..."
185for d in $dotfilessubst; do
186 case $d in
187 *:*) target=${d#*:} d=${d%%:*};;
188 *) target=.$d d=$d.in;;
189 esac
190 ft=$HOME$sub/$target
191 dir=${ft%/*}
192 mkdir -p $dir
193 sed "
2b5d4580
MW
1941i\\
195### generated by $here/setup; do not edit!\\
403dc178
MW
196
197/@home@/ s\a\a$HOME\ag
73165cde 198/@profile@/ s\a\a$here\ag
bf674ae1 199/@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
403dc178
MW
200" dot/$d >$ft.new
201 mv $ft.new $ft
202 echo " $target"
203done
204echo " all done."
205
f4e43257 206## Symlink backgrounds.
960af1a5
MW
207backgrounds="
208 jue-peek.jpg
209 medusa.jpg
5236501e 210 bsg-supper.jpg
960af1a5 211 rayne.jpg
56c871ef 212 hypatia.jpg
e1ca556b 213 noodly.jpg
9f56284f 214 lilith.jpg
e1ca556b 215 lovelace.jpg"
f4e43257
MW
216if [ "$xstuff" ]; then
217 echo "Installing backgrounds..."
218 for b in $backgrounds; do
219 for e in enlightenment e16; do
220 dir=$HOME$sub/.$e/backgrounds
221 t=$dir/$b
222 mkdir -p $dir
99063107 223 ln -s $here/bg/$b $t.new
f4e43257
MW
224 mv $t.new $t
225 done
226 echo " $b"
227 done
228 echo " all done."
229fi
230
ce178f96
MW
231###--------------------------------------------------------------------------
232### Install useful scripts included in this package.
233
e04c4857 234scripts="
547fb8af 235 mdw-editor
b20bfd83 236 mdw-pager
b056f5c4 237 mdw-conf
7ee12623 238 mdw-build
c4e84cb1 239 emacsclient-hack
8e08f814 240 movemail-hack
aaa2d943 241 sendmail-hack
68b2e9e6 242 aspell-hack
285a1386
MW
243 emerge-hack
244 lesspipe.sh
245 start-ssh-agent
4cdeb0d0 246 svnwrap
73bb9001 247 guest-console
4cdeb0d0 248 hyperspec"
8e08f814 249[ "$xstuff" ] && scripts="$scripts
3bdada49 250 xinitcmd
34a5ea4e 251 un-backslashify-selection
c02999e8 252 lock-screen
8e08f814 253 xshutdown"
e04c4857
MW
254echo "Installing scripts..."
255mkdir -p $HOME$sub/bin
256for s in $scripts; do
257 ft=$HOME$sub/bin/$s
99063107 258 ln -s $here/bin/$s $ft.new
e04c4857
MW
259 mv $ft.new $ft
260 echo " $s"
261done
262echo " all done."
263
4d7d040b
MW
264hacks="
265 ssh:ssh"
266echo "Installing hacks..."
267for h in $hacks; do
268 d=${h%%:*} h=${h#*:}
269 ft=$HOME$sub/bin/hacks/$d
270 mkdir -p $ft
271 ln -s $here/hacks/$h $ft/$h.new
272 mv $ft/$h.new $ft/$h
273 echo " $d:$h"
274done
275echo " all done."
276
ce178f96
MW
277###--------------------------------------------------------------------------
278### Set up the Emacs config.
279
65ff0e8c
MW
280$echon "Finding a suitable emacs:$echoc"
281emacs=no
5fe24792 282for i in emacs22 emacs23 emacs21 emacs; do
65ff0e8c
MW
283 if type -p >/dev/null $i; then
284 emacs=$i
285 break
286 fi
287done
288if [ $emacs = no ]; then
289 echo " failed."
290 emacs=:
291else
292 echo " $emacs."
293fi
294
f617db13 295echo "Installing Emacs packages..."
400223a1
MW
296emacspkg="
297 make-regexp
a1293ade 298 ew-hols
a3bdb4d9 299 mdw-gnus-patch
1778b496 300 git git-blame vc-git stgit
c6fe19d5 301 mdw-multiple-cursors
400223a1
MW
302 quilt"
303for elib in $emacspkg; do
f617db13 304 $echon " $elib:$echoc"
65ff0e8c 305 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 306 (progn
852cd5fb
MW
307 (setq load-path (nconc load-path (list "~/lib/emacs")))
308 (kill-emacs (condition-case nil
309 (progn (load-library "'"$elib"'") 0)
20eb0692 310 (error 1))))'; then
f617db13
MW
311 echo " already installed."
312 else
99063107
MW
313 if [ -f el/$elib.el ]; then
314 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
a3bdb4d9
MW
315 else
316 $echon " downloading$echoc"
317 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
318 fi
f617db13
MW
319 $echon " compiling$echoc"
320 (cd $HOME$sub/lib/emacs;
65ff0e8c 321 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 322 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
323 echo " done."
324 fi
325done
852cd5fb 326echo " all done."
f617db13
MW
327
328$echon "Setting up Emacs configuration:$echoc"
329$echon " linking$echoc"
99063107 330for f in dot-emacs.el Makefile; do
f617db13 331 set -- $(echo $link | tr : ' ')
99063107
MW
332 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
333 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
f617db13
MW
334done
335$echon " compiling$echoc"
c39d1139 336{ cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
f617db13 337echo " done."
ce178f96
MW
338
339###----- That's all, folks --------------------------------------------------